#include <SFE_TSL2561.h>
#include <SFE_BMP180.h>
#include <Wire.h>
#include "DHT.h"
#include <SPI.h>
#include <Ethernet.h>
float ve;
char s[50];
float count;
boolean Debug = true;
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xEA }; //MAC-адрес Arduino

#define postingInterval  600000
IPAddress server(92,39,235,156); // IP сервера народного мониторинга
EthernetClient client;
EthernetServer server1(80); 
unsigned long lastConnectionTime = 0;           // время последней передачи данных
boolean lastConnected = false;                  // состояние подключения
byte ip[]={192, 168, 6, 24};
byte k[] = {192, 168, 6, 111}; 
byte gateway[] = {192, 168, 6, 111}; 
byte subnet[] = {255, 255, 255, 0}; 
char replyBuffer[160];                          // буфер для отправки
        
char macbuf[13];
#define PIN3 3

double T,P,p0,a;
  double lux,la; 
  float humidity ;
  float temperature;
int a1, b, c, d;
float polozenie;
 int m1;
 int m2=0;

int rainy;
DHT dht;
SFE_TSL2561 light;
SFE_BMP180 pressure;
int f=16;
boolean gain;
unsigned int ms; 
void setup() 
{if (Debug)
  {
    Serial.begin(9600);
  }
 
  // Пробуем подключиться по Ethernet до тех пор пока это не удастся
  Serial.println("Connecting by Ethernet!");
  Ethernet.begin(mac,ip,k,gateway,subnet);
 
  Serial.println("Connected");
  server1.begin();
  lastConnectionTime = millis()-postingInterval+2000;
  Serial.begin(9600);
  pinMode(PIN3, INPUT);


  Serial.begin(9600);
  Serial.println("---------------------------------------");

   
  if (pressure.begin())
    Serial.println("BMP180 init success");
  else
  { 
    // Оп, что-то пошло не так, обычно это проблема соединения
    Serial.println("BMP180 init fail\n\n");
    while(1); // навсегда остановиться
  }

 light.begin();
   gain = 0;
     unsigned char time = 1;
       light.setTiming(gain,time,ms);
        light.setPowerUp();
  
  dht.setup(5);
}

unsigned long time=0;
void loop() {

   

wind();
pressur(); 
ligh();
humidit();




v();
ethernet();
local();
}
void ethernet()
{
  if (client.available()) 
  {
    client.read();
  }
 
  if (!client.connected() && lastConnected) 
  {
    if (Debug)
    {
      Serial.println();
      Serial.println("disconnecting.");
    }
    client.stop();
  }
  if (!client.connected() && (millis() - lastConnectionTime > postingInterval)) 
  {
    //формирование HTTP-запроса
    memset(replyBuffer, 0, sizeof(replyBuffer));
    strcpy(replyBuffer,"ID=");
    strcat(replyBuffer, "DEADBEEFFEEA");
    strcat(replyBuffer,"&");
    strcat(replyBuffer, "T1=");
    itoa(temperature,s);
    strcat(replyBuffer, s);
    
    //strcat(replyBuffer, temperature);
    strcat(replyBuffer, "&");
    
    strcat(replyBuffer, "T2=");
    itoa(T,s);
    strcat(replyBuffer, s);
    strcat(replyBuffer, "&");
         
         strcat(replyBuffer, "P=");
         itoa(P,s);
         strcat(replyBuffer, s); 
    //strcat(replyBuffer, P*0.75006156130,2);
    strcat(replyBuffer, "&");
 //   strcat(replyBuffer, macbuf);
  
    strcat(replyBuffer, "H=");
    itoa(humidity,s);
    strcat(replyBuffer, s);
    //strcat(replyBuffer, humidity);
  
   strcat(replyBuffer, "&");
    strcat(replyBuffer, "L=");
    itoa(lux,s);
    strcat(replyBuffer, s);
    //strcat(replyBuffer, lux);

//
//   strcat(replyBuffer, "&");
//    strcat(replyBuffer, "P=1");
//    //strcat(replyBuffer, P*0.75006156130,2);

    strcat(replyBuffer, "&");
    strcat(replyBuffer, "W1=");
    itoa(count,s);
    strcat(replyBuffer, s);
    strcat(replyBuffer, "&");
    
    strcat(replyBuffer, "W2=");
    if (polozenie==90) strcat(replyBuffer, "90"); 
 if (polozenie==67.5) strcat(replyBuffer, "67.5");
 if (polozenie==45) strcat(replyBuffer, "45");  
 if (polozenie==22.5) strcat(replyBuffer, "22.5"); 
 if (polozenie==0)strcat(replyBuffer, "0");  
 if (polozenie==337.5) strcat(replyBuffer, "337.5");  
 if (polozenie==315) strcat(replyBuffer, "315");  
 if (polozenie==292.5) strcat(replyBuffer, "292.5");  
 if (polozenie==270) strcat(replyBuffer, "270"); 
 if ( polozenie==247.5) strcat(replyBuffer, "247.5"); 
 if (polozenie==225) strcat(replyBuffer, "225");  
 if ( polozenie==202.5) strcat(replyBuffer, "202.5"); 
 if (polozenie==180) strcat(replyBuffer, "180"); 
 if (polozenie==157.5) strcat(replyBuffer, "157.5");  
 if (polozenie==135) strcat(replyBuffer, "135");  
 if (polozenie==112.5) strcat(replyBuffer, "112.5");  
    //strcat(replyBuffer, count);
    strcat(replyBuffer, "&lat=61.0407");
    strcat(replyBuffer, "&lng=30.135");
 
 strcat(replyBuffer,'\0');
    if (Debug)
    {
      Serial.println(replyBuffer);
      Serial.print("Content-Length: ");
      Serial.println(len(replyBuffer));
    }
 
    //отправляем запрос
    httpRequest();
  }
  lastConnected = client.connected();

}
void httpRequest() 
{
  if (client.connect(server, 80))
  {
    if (Debug)
    {
      Serial.println("connecting...");
    }
    // отправляем HTTP POST запрос:
    client.println("POST http://narodmon.ru/post.php HTTP/1.0");
    client.println("Host: narodmon.ru");
    client.println("Content-Type: application/x-www-form-urlencoded");
    client.print("Content-Length: ");
    client.println(len(replyBuffer));
    client.println();
    client.println(replyBuffer);
    client.println();
 Serial.println("GOOD");
    lastConnectionTime = millis();
  } 
  else
  {
    if (Debug)
    {
      Serial.println("connection failed");
      Serial.println("disconnecting.");
    }
    client.stop();
  }
}
void itoa(float k,char s[]){
int i, sign;

sign = k;
  if (k < 0)  /* записываем знак */
    k = -k; 
  unsigned long n2=round(k*10);
  k=n2/10;
  unsigned long n=(int)k;
  
  s[0]=n2%10+'0';
  
  s[1]='.';
   /* делаем n положительным числом */
  i = 2;
  do {                      /* генерируем цифры в обратном порядке */
    s[i++] = n % 10+'0';
    /* берем следующую цифру */
  } while ((n=n/10) > 0);  /* удаляем */
  if (sign < 0)
    s[i++] = '-';
  s[i] = '\0';
  reverse(s);
  
}
void reverse(char s[])
{
  int i, j;
  char c;
 
  for (i = 0, j = strlen(s)-1; i<j; i++, j--) 
  {
    c = s[i];
    s[i] = s[j];
    s[j] = c;
  }
}
void local() {
  // listen for incoming clients
  EthernetClient client1 = server1.available();
  if (client1) {
    Serial.println("new client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client1.connected()) {
      if (client1.available()) {
        char c = client1.read();
        Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
         
            client1.print("temperature1");
          
            client1.print(" ");
            client1.println(temperature);
            client1.print("temperature2");
            client1.print(" ");
            client1.println(T);
            
            client1.print("humidity");
            
            client1.print(" ");
            client1.println(humidity);
            
            client1.print("l");
            client1.print(" ");
            client1.println(lux);
            Serial.print("v2 ");
            Serial.println(ve);
            client1.print("Speed");
            client1.print(" ");
            client1.println(ve);
            
            client1.print("wind");
            client1.print(" ");
           
            client1.println(polozenie);
            
            client1.print("pressue");
            client1.print(" ");
            client1.print(P);
            
            
          
          
          break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        } else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client1.stop();
    Serial.println("client disconnected");
  }
} 
//Функция определения длины строки
int len(char *buf)
{
  int i=0; 
  do
  {
    i++;
  } while (buf[i]!='\0');
  return i;
}
void v()
{int x=0;
unsigned long ti=millis();

   while (millis()<ti+1000)
   { m1=digitalRead(PIN3);
     if (m1!=m2)
     {x++;
     m2=m1;}
   }

  Serial.print("v");
count=0.000017946*x*x*x - 0.0032434897*x*x + 0.2508619007*x;

Serial.println(count);
ve=count;

}




void wind()
{
 
 int photo4 = analogRead(A0);
 int photo3 = analogRead(A1);
 int photo2 = analogRead(A2);
 int photo1 = analogRead(A3);
 
 if (photo4<100 ) a1=0; else a1=1;
 if (photo3<100 ) b=0; else b=1;
 if (photo2<100 ) c=0; else c=1;
 if (photo1<900) d=0; else d=1;
 if (a1==0&&b==0&&c==0&&d==0) polozenie=90;
 if (a1==0&&b==0&&c==0&&d==1) polozenie=67.5;
 if (a1==0&&b==0&&c==1&&d==1) polozenie=45;
 if (a1==0&&b==0&&c==1&&d==0) polozenie=22.5;
 if (a1==0&&b==1&&c==1&&d==0) polozenie=0;
 if (a1==0&&b==1&&c==1&&d==1) polozenie=337.5;
 if (a1==0&&b==1&&c==0&&d==1) polozenie=315;
 if (a1==0&&b==1&&c==0&&d==0) polozenie=292.5;
 if (a1==1&&b==1&&c==0&&d==0) polozenie=270;
 if (a1==1&&b==1&&c==0&&d==1) polozenie=247.5;
 if (a1==1&&b==1&&c==1&&d==1) polozenie=225;
 if (a1==1&&b==1&&c==1&&d==0) polozenie=202.5;
 if (a1==1&&b==0&&c==1&&d==0) polozenie=180;
 if (a1==1&&b==0&&c==1&&d==1) polozenie=157.5;
 if (a1==1&&b==0&&c==0&&d==1) polozenie=135;
 if (a1==1&&b==0&&c==0&&d==0) polozenie=112.5;

// Serial.print(polozenie);
// Serial.print(" ");
// Serial.print(photo4);
// Serial.print(" ");
// Serial.print(photo3);
// Serial.print(" ");
// Serial.print(photo2);
// Serial.print(" ");
// Serial.println(photo1);
//
}


void pressur ()
{char status;


  //Чтобы измерить давление, сначала нужно измерить температуру

  // Начало мзмерения температуры
  
  //Выполняется измерение температуры, если успешно в status записывается количество секунд для ожидания, запрос не успешен, возвращается 0
  
  status = pressure.startTemperature();
  if (status != 0)
  {
    // Подождать пока измерение закончится:
    delay(status);

    // Получить измеренное значение температуры (запишется в пременную T в градусах Цельсия):
    // Вернет 0, если неуспешно.

    status = pressure.getTemperature(T);
    if (status != 0)
    {
     
    
      // Выполняется измерение давления
      // Параметр в скобках - точность от 0 до 3 (больше точность-дольше ждать).
      // Если успешно в status записывается количество секунд для ожидания, запрос не успешен, возвращается 0

      status = pressure.startPressure(3);
      if (status != 0)
      {
        // Подождать пока измерение закончится:
        delay(status);
        //Получить измеренное значение давления
        //Значение запишется в переменную P, так же для измерения необходимо предыдущее измерение температуры T
        //Если температура стабильна, можно делать несколько измерений давления на одно измерение температуры)
        
        status = pressure.getPressure(P,T);
        if (status != 0)
        {        
          P=P*0.75006156130,2;
          //Возвращаемо давление P ищмеряется в миллибарах (или гектопаскалях)
          //чтобы перевести в мм.рт.ст. умножаем на 0.75006156130
        }
        else Serial.println("error retrieving pressure measurement\n");
      }
      else Serial.println("error starting pressure measurement\n");
    }
    else Serial.println("error retrieving temperature measurement\n");
  }
  else Serial.println("error starting temperature measurement\n");

 
}
void ligh()
{
unsigned int data0, data1;
if (light.getData(data0,data1))
{ delay(ms);
 boolean good = light.getLux(gain,ms,data0,data1,lux);
}
Serial.print("l ");
Serial.println(lux);}
void humidit()
{dht.getMinimumSamplingPeriod();

  humidity = dht.getHumidity();
  temperature = dht.getTemperature();
dht.getStatusString();

 
}

